﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace movedemos
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void movedir(string dir, FileInfo File)
        {
            dir = sl(dir);
            DirectoryInfo tempdir = new DirectoryInfo(dir);
            if (!tempdir.Exists)
                tempdir.Create();
            FileInfo fil = new FileInfo(tempdir.FullName + File.Name);
            if(!fil.Exists)
                File.MoveTo(tempdir.FullName + File.Name);
        }
        private string sl(string dir) 
        {
            dir = dir.Replace("\\\\", "\\");
            return dir;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                DirectoryInfo filedemos = new DirectoryInfo(textBox1.Text);
                DirectoryInfo dirdemos = new DirectoryInfo(textBox2.Text);
                int i1 = 0, i2 = 0, i3 = 0;
                DirectoryInfo tempdir = new DirectoryInfo(textBox2.Text);
                if (filedemos.Exists && dirdemos.Exists)
                {
                    progressBar1.Maximum = filedemos.GetFiles().Length;
                    foreach (FileInfo NextFile in filedemos.GetFiles())
                    {
                        progressBar1.Value++;
                        if (NextFile.Extension == ".dm_68" || NextFile.Extension == ".dm_67")
                        {
                            if (textBox3.Text.Length > 0)
                            {
                                i1 = i2 = i3 = 0;
                                i1 = NextFile.Name.IndexOf("[");
                                if (i1 > 0) i2 = NextFile.Name.IndexOf("]", i1);
                                if (i2 > 0) i3 = NextFile.Name.IndexOf(textBox3.Text, i2);

                                if (i1 > 0 && i2 > 0 && i3 > 0)
                                {
                                    if (NextFile.Name[0].CompareTo('a') < 0 || NextFile.Name[0].CompareTo('z') > 0)
                                        movedir(dirdemos.FullName + "\\1\\", NextFile);
                                    else
                                        movedir(sl(dirdemos.FullName + "\\" + NextFile.Name[0] + "\\"), NextFile);
                                }
                                else
                                    movedir(dirdemos.FullName + "\\!not my\\", NextFile);
                            }
                            else
                            {
                                if (NextFile.Name[0].CompareTo('a') < 0 || NextFile.Name[0].CompareTo('z') > 0)
                                    movedir(dirdemos.FullName + "\\1\\", NextFile);
                                else
                                    movedir(dirdemos.FullName + "\\" + NextFile.Name[0] + "\\", NextFile);
                            }
                        }
                    }
                    MessageBox.Show("Moving demos was completed", "Complete", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    if (!filedemos.Exists)
                        MessageBox.Show("Directory error","Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    else
                    {
                        try { dirdemos.Create(); }
                        catch (Exception ex) { MessageBox.Show(ex.Message,"Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
                        button1_Click(sender, e);
                    }
                }
            }
            catch (Exception ex) { MessageBox.Show(ex.Message,"Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            textBox1.Text = Application.ExecutablePath.Substring(0, Application.ExecutablePath.Length - Path.GetFileName(Application.ExecutablePath).Length);

            DirectoryInfo filedemos = new DirectoryInfo(textBox1.Text);
            FileInfo NextFile = filedemos.GetFiles()[0];
            int i1 = 0, i2 = 0, i3 = 0;
            i1 = NextFile.Name.IndexOf("(", i1);
            if (i1 > 0)
            {
                i2 = NextFile.Name.IndexOf(".", i1);
                i3 = NextFile.Name.IndexOf(")", i1);
            }
            if (i1 > 0 && i3 > 0)
            {
                if (i2 > 0) textBox3.Text = NextFile.Name.Substring(i1 + 1, i2 - (i1 + 1));
                else textBox3.Text = NextFile.Name.Substring(i1 + 1, i3 - (i1 + 1));
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog demosBrowz = new FolderBrowserDialog();
            demosBrowz.Description = label1.Text;
            demosBrowz.SelectedPath = textBox1.Text;
            if (demosBrowz.ShowDialog() == System.Windows.Forms.DialogResult.OK && demosBrowz.SelectedPath.Length > 0)
            {
                textBox1.Text = demosBrowz.SelectedPath;
                textBox1.Text = sl(textBox1.Text + "\\");
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog newDemosBrowz = new FolderBrowserDialog();
            newDemosBrowz.Description = label2.Text;
            newDemosBrowz.SelectedPath = textBox1.Text;
            if (newDemosBrowz.ShowDialog() == System.Windows.Forms.DialogResult.OK && newDemosBrowz.SelectedPath.Length > 0)
            {
                textBox2.Text = newDemosBrowz.SelectedPath;
            }
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            try
            {
                DirectoryInfo tempdir = new DirectoryInfo(textBox1.Text);
                if (tempdir.Exists) textBox2.Text = sl(tempdir.FullName + "\\!demos\\");
            }
            catch { }
        }
    }
}
